.object-viewer {
  position: relative;
  font-family: monospace, monospace;
  padding-right: 1.5em;

  button.btn-copy {
    position: absolute;
    right: 0;
  }

  .level {
    &,
    > details > summary {
      white-space: nowrap;

      > * {
        white-space: normal;
      }
    }

    .structure {
      text-shadow: 1px 1px black;

      &.level-prefix {
        margin-right: 0.3em;
      }

      &.value-postfix {
        margin-left: 1px;
      }
    }

    > details {
      @include details-influence(
        (
          details: '&',
          inner-selector: '.badge',
          next-rule: '+',
        )
      );

      &.collapsable {
        display: inline-block;

        &[open] .badge {
          pointer-events: none;
        }
      }

      &.complex > summary {
        list-style-position: outside;
      }
    }

    &.in-array {
      list-style-type: square;
    }

    &:not(.in-array) {
      list-style-type: disc;
    }

    &.diff .badge {
      border: 2px solid red;
    }

    &:not(.complex) {
      white-space: nowrap;
    }

    &.complex {
      list-style-type: none;
    }
  }

  &.can-copy {
    details.collapsable > summary {
      margin-right: 1em;
    }
  }
}
